#include <iostream>

using namespace std;

int main()
{
    long long N, M, i, j, Q, put=0;
    cin>>N>>M;
    long long mat[N][M];
    for (i=0; i<N; i++)
    {
        for (j=0; j<M; j++)
        {
            cin>>mat[i][j];
        }
    }
    cin>>Q;
    long long matq[1][Q];
    for (i=0; i<Q; i++)
    {
        cin>>matq[0][i]>>matq[1][i];
    }
    //napravljeno kao da nema Q, ne radi
    i=0;
    j=0;
    while (i!=N-1 && j!=M-1)
    {
        if (mat[i+1][j]<=mat[i][j+1] && mat[i+1][j]!=0)
        {
            put+=mat[i+1][j];
            i++;
        }
        else 
        {
            put+=mat[i][j+1];
            j++;
        }
    }
    cout<<put;

    return 0;
}